searchNodes=[{"doc":"Parse and validate your environment variables easily in Elixir with the following benefits. Compile time access guarantees Parsed values with accurate elixir data types Validation of required values before app boot mix environment specific defaults and fallbacks Code autocompletion (if using elixir language server) Read more for understanding why to use this package and its benefits. The complete documentation for mahaul is available online at HexDocs . Requirements Elixir 1.13+ Installation Add mahaul to your list of dependencies in mix.exs : def deps do [ { :mahaul , &quot;~&gt; 0.6.0&quot; } ] end Run mix deps.get Add config in your config/config.exs file config :mahaul , mix_env : Mix . env ( ) Getting started Define the environment variables needed in your app defmodule MyApp.Env do use Mahaul , DEPLOYMENT_ENV : [ type : :enum , defaults : [ dev : &quot;dev&quot; , test : &quot;dev&quot; ] , choices : [ :dev , :staging , :live ] ] , PORT : [ type : :port , defaults : [ dev : &quot;4000&quot; ] ] , DATABASE_URL : [ type : :uri , defaults : [ dev : &quot;postgresql://user:pass@localhost:5432/app_dev&quot; ] ] , ANOTHER_ENV : [ type : :host , default : &quot;//localhost&quot; ] end Use in config/runtime.exs import Config if config_env ( ) == :dev do MyApp.Env . validate ( ) config :my_app , MyApp.Endpoint , http : [ port : MyApp.Env . port ( ) ] end if config_env ( ) == :prod do MyApp.Env . validate! ( ) config :my_app , MyApp.Repo , url : MyApp.Env . database_url ( ) config :my_app , :something , another : MyApp.Env . another_env ( ) if MyApp.Env . deployment_env ( ) == :staging do # configure something more end end Use anywhere in the code defmodule MyApp.Magic def do_magic ( env \\\\ MyApp.Env . deployment_env ( ) ) def do_magic ( :live ) , do : &quot;Magic on live&quot; def do_magic ( :staging ) , do : &quot;Magic on staging&quot; def do_magic ( :dev ) , do : &quot;Magic on dev&quot; end Supported types The following type configurations are supported. Type Elixir Type Valid Environment variables value :str String Any string :enum Atom Any string :num Float Any string that can be parsed as float :int Integer Any string that can be parsed as integer :bool Boolean &quot;true&quot; and &quot;1&quot; as true ; &quot;false&quot; and &quot;0&quot; as false :port Integer Any valid port value between &quot;1&quot; to &quot;65535&quot; (casted as integer) :host String Any valid host name :uri String Any valid uris Setting Defaults Any defaults and fallback values can be set globally using the default or for any mix environment using the defaults configuration options. Make sure to use the string values same as we set in the actual system environment, as it will be parsed depending upon the provided type configuration. Globally defmodule MyApp.Env do use Mahaul , MY_ENV : [ type : :str , default : &quot;Hello World&quot; ] end iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello World MY_ENV = &quot;Hello Universe&quot; iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Universe For any mix environment defmodule MyApp.Env do use Mahaul , MY_ENV : [ type : :str , defaults : [ prod : &quot;Hello Prod&quot; , dev : &quot;Hello Dev&quot; , test : &quot;Hello Test&quot; , custom : &quot;Hello Custom&quot; ] ] end MIX_ENV = prod iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Prod MIX_ENV = dev iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Dev MIX_ENV = test iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Test MIX_ENV = custom iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Custom MIX_ENV = prod MY_ENV = &quot;Hello World&quot; iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello World For any mix environment with fallback defmodule MyApp.Env do use Mahaul , MY_ENV : [ type : :str , default : &quot;Hello World&quot; , defaults : [ prod : &quot;Hello Prod&quot; , dev : &quot;Hello Dev&quot; , test : &quot;Hello Test&quot; ] ] end MIX_ENV = prod iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Prod MIX_ENV = dev iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Dev MIX_ENV = test iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Test MIX_ENV = custom iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello World MIX_ENV = custom MY_ENV = &quot;Hello Universe&quot; iex - S mix iex&gt; MyApp.Env . my_env ( ) Hello Universe Setting choices list You can further restrict the parsed values to a predefined list by setting the choices option with list of allowed values. Note that the values are parsed first and then matched against the provided list. defmodule MyApp.Env do use Mahaul , DEPLOYMENT_ENV : [ type : :enum , choices : [ :dev , :staging , :live ] ] , DAY_OF_WEEK : [ type : :int , choices : [ 1 , 2 , 3 , 4 , 5 , 6 , 7 ] ] end Setting documentation There is a default documentation added for each of the compile time generated function equivalents for the environment variables. However you may use the doc option to add a custom documentation with more details and explanations as per your needs. Default defmodule MyApp.Env do use Mahaul , PORT : [ type : :port , defaults : [ dev : &quot;4000&quot; ] ] end Custom defmodule MyApp.Env do use Mahaul , PORT : [ type : :port , defaults : [ dev : &quot;4000&quot; ] , doc : ~s&quot;&quot;&quot; This is an example documentation for the environment variable. We can use all the features from the elixir `@doc` tag that will appear as the function documentation during its usage. ## Usage Env.port() ## Notes These are some notes to keep in mind. &quot;&quot;&quot; ] end Why this package mahaul accomplishes the following functionalities for streamlining the environment variables requirements for an elixir app. Compile time access guarantees Using the meta programming capabilities of Elixir, mahaul creates compile time methods for accessing the environment variables. This guarantees that there are no accidental typos during the access of the environment variables from the code. Also as an added bonus, if you are using the Elixir Language Server for your development environment, you'd get code autocompletion. Parsed values with accurate data types Depending upon the configuration, the access to the predefined environment variables string values are parsed and the correct elixir data types are returned. mahaul supports a wide range of commonly set environment variable types. It also supports the choices options to limit the allowed values for an environment variable. Validation of required values before app boot Often times we release new versions of the app accessing new environment variables, but we forget to set those for one of our app deployments. This creates nasty bugs that are only discovered when certain parts of the app behaves erratically or fails. With mahaul , you can pre-validate the existence of the required environment variables with correct values before booting the app (ideally in config/runtime.exs ). This ensures that your application will fail to boot unless you have set those environment variables with correct values. This works really well with any cloud deployments that makes new version of your app active and available only after ensuring the new deployment had a successful boot. Defaults and fallbacks You can set default values for the production or development environment of your app while configuring mahaul . This comes handy when you want some defaults for dev/test environment to let other contributors of your app quickly start the dev environment of your app without worrying to set some needed environment variables. Or have some sensible defaults for production version of your app with flexibility to change the values by setting an environment variable. Contributing Contributions are welcome. Please follow the commit guidelines from https://www.conventionalcommits.org . Setup Clone the repo and fetch its dependencies: git clone https://github.com/emadalam/mahaul.git cd mahaul mix setup Running tests mix test # or with coverage threshold # mix coveralls Building docs MIX_ENV=docs mix docs # or view the docs # MIX_ENV=docs mix docs --open LICENSE See LICENSE","ref":"Mahaul.html","title":"Mahaul","type":"module"},{"doc":"Module for dealing with the configuration options for initialization.","ref":"Mahaul.Configs.html","title":"Mahaul.Configs","type":"module"},{"doc":"Validates the initialization options. The options keyword list is validated for any missing or invalid configuration option. The method throws ArgumentError for any misconfigured option.","ref":"Mahaul.Configs.html#validate_opts!/1","title":"Mahaul.Configs.validate_opts!/1","type":"function"},{"doc":"Common constants and types.","ref":"Mahaul.Constants.html","title":"Mahaul.Constants","type":"module"},{"doc":"iex&gt; Mahaul.Constants . error_tuple ( ) { :error , nil }","ref":"Mahaul.Constants.html#error_tuple/0","title":"Mahaul.Constants.error_tuple/0","type":"function"},{"doc":"iex&gt; Mahaul.Constants . mix_env ( ) :prod","ref":"Mahaul.Constants.html#mix_env/0","title":"Mahaul.Constants.mix_env/0","type":"function"},{"doc":"iex&gt; Mahaul.Constants . required_opts ( ) [ :type ]","ref":"Mahaul.Constants.html#required_opts/0","title":"Mahaul.Constants.required_opts/0","type":"function"},{"doc":"iex&gt; Mahaul.Constants . supported_types ( ) [ :str , :enum , :num , :int , :bool , :port , :host , :uri ]","ref":"Mahaul.Constants.html#supported_types/0","title":"Mahaul.Constants.supported_types/0","type":"function"},{"doc":"The configuration options type.","ref":"Mahaul.Constants.html#t:config_type/0","title":"Mahaul.Constants.config_type/0","type":"type"},{"doc":"The common error type.","ref":"Mahaul.Constants.html#t:error_type/0","title":"Mahaul.Constants.error_type/0","type":"type"},{"doc":"The type representing a normalized environment variable value.","ref":"Mahaul.Constants.html#t:normalized_value_type/0","title":"Mahaul.Constants.normalized_value_type/0","type":"type"},{"doc":"The type representing list of all normalized environment variable values.","ref":"Mahaul.Constants.html#t:normalized_values_type/0","title":"Mahaul.Constants.normalized_values_type/0","type":"type"},{"doc":"The common success type.","ref":"Mahaul.Constants.html#t:success_type/0","title":"Mahaul.Constants.success_type/0","type":"type"},{"doc":"The supported environment variable value type.","ref":"Mahaul.Constants.html#t:value_type/0","title":"Mahaul.Constants.value_type/0","type":"type"},{"doc":"The supported environment variable type.","ref":"Mahaul.Constants.html#t:var_type/0","title":"Mahaul.Constants.var_type/0","type":"type"},{"doc":"Module for dealing with environment variable values.","ref":"Mahaul.Env.html","title":"Mahaul.Env","type":"module"},{"doc":"Returns a list of normalized environment variable values.","ref":"Mahaul.Env.html#get_all_normalized_values/1","title":"Mahaul.Env.get_all_normalized_values/1","type":"function"},{"doc":"Returns the parsed environment variable value. The type parsing is done as per the provided configuration options. If the default configuration option is provided and the environment variable is not set, the default value is parsed and returned. An error tuple is returned in all other cases.","ref":"Mahaul.Env.html#get_env/2","title":"Mahaul.Env.get_env/2","type":"function"},{"doc":"Returns the normalized environment variable value for a given environment variable name and configuration option.","ref":"Mahaul.Env.html#get_normalized_value/1","title":"Mahaul.Env.get_normalized_value/1","type":"function"},{"doc":"Basic helpers for parsing and validating the system environment variables.","ref":"Mahaul.Helpers.html","title":"Mahaul.Helpers","type":"module"},{"doc":"Returns a valid parsed environment variable value or nil .","ref":"Mahaul.Helpers.html#get_env/2","title":"Mahaul.Helpers.get_env/2","type":"function"},{"doc":"Returns a list of parsed environment variable values. See Mahaul.Env.get_all_normalized_values/1 .","ref":"Mahaul.Helpers.html#parse_all/1","title":"Mahaul.Helpers.parse_all/1","type":"function"},{"doc":"Validates the list of parsed environment variables. Given a list of parsed environment variables, the method validates the list to contain all valid environment variables. For any invalid values, the method logs the name of the missing environment variable and returns the list of errors.","ref":"Mahaul.Helpers.html#validate/1","title":"Mahaul.Helpers.validate/1","type":"function"},{"doc":"Validates and throws error for invalid environment variables. Same as validate/1 , except that it raises exception on error.","ref":"Mahaul.Helpers.html#validate!/1","title":"Mahaul.Helpers.validate!/1","type":"function"},{"doc":"Validates the initialization options. See Mahaul.Configs.validate_opts!/1 .","ref":"Mahaul.Helpers.html#validate_opts!/1","title":"Mahaul.Helpers.validate_opts!/1","type":"function"},{"doc":"Module for parsing string to supported environment variables.","ref":"Mahaul.Parser.html","title":"Mahaul.Parser","type":"module"},{"doc":"Parses a string value into one of the supported types. Given a string value and the supported type configuration, the method tries to parse the string into the provided type. A success tuple is returned if parsing was successful, otherwise an error tuple is returned. :str iex&gt; Mahaul.Parser . parse ( &quot;some value&quot; , :str ) { :ok , &quot;some value&quot; } :enum iex&gt; Mahaul.Parser . parse ( &quot;atom&quot; , :enum ) { :ok , :atom } iex&gt; Mahaul.Parser . parse ( &quot;value&quot; , :enum ) { :ok , :value } :num iex&gt; Mahaul.Parser . parse ( &quot;10&quot; , :num ) { :ok , 10.0 } iex&gt; Mahaul.Parser . parse ( &quot;10.2345&quot; , :num ) { :ok , 10.2345 } iex&gt; Mahaul.Parser . parse ( &quot;some value&quot; , :num ) { :error , nil } :int iex&gt; Mahaul.Parser . parse ( &quot;10&quot; , :int ) { :ok , 10 } iex&gt; Mahaul.Parser . parse ( &quot;10.2345&quot; , :int ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;some value&quot; , :int ) { :error , nil } :bool iex&gt; Mahaul.Parser . parse ( true , :bool ) { :ok , true } iex&gt; Mahaul.Parser . parse ( false , :bool ) { :ok , false } iex&gt; Mahaul.Parser . parse ( &quot;true&quot; , :bool ) { :ok , true } iex&gt; Mahaul.Parser . parse ( &quot;false&quot; , :bool ) { :ok , false } iex&gt; Mahaul.Parser . parse ( &quot;1&quot; , :bool ) { :ok , true } iex&gt; Mahaul.Parser . parse ( &quot;0&quot; , :bool ) { :ok , false } :port iex&gt; Mahaul.Parser . parse ( &quot;1&quot; , :port ) { :ok , 1 } iex&gt; Mahaul.Parser . parse ( &quot;65535&quot; , :port ) { :ok , 65535 } iex&gt; Mahaul.Parser . parse ( &quot;8080&quot; , :port ) { :ok , 8080 } iex&gt; Mahaul.Parser . parse ( &quot;some value&quot; , :port ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;-1&quot; , :port ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;0&quot; , :port ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;65536&quot; , :port ) { :error , nil } :host iex&gt; Mahaul.Parser . parse ( &quot;//localhost&quot; , :host ) { :ok , &quot;//localhost&quot; } iex&gt; Mahaul.Parser . parse ( &quot;//domain.com&quot; , :host ) { :ok , &quot;//domain.com&quot; } iex&gt; Mahaul.Parser . parse ( &quot;//192.168.0.1&quot; , :host ) { :ok , &quot;//192.168.0.1&quot; } iex&gt; Mahaul.Parser . parse ( &quot;ftp://localhost&quot; , :host ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;https://domain.com&quot; , :host ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;https&quot; , :host ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;https://domain.com/something&quot; , :host ) { :error , nil } :uri iex&gt; Mahaul.Parser . parse ( &quot;ftp://localhost&quot; , :uri ) { :ok , &quot;ftp://localhost&quot; } iex&gt; Mahaul.Parser . parse ( &quot;https://domain.com&quot; , :uri ) { :ok , &quot;https://domain.com&quot; } iex&gt; Mahaul.Parser . parse ( &quot;postgresql://user:pass@localhost:5432/dev_db&quot; , :uri ) { :ok , &quot;postgresql://user:pass@localhost:5432/dev_db&quot; } iex&gt; Mahaul.Parser . parse ( &quot;//localhost&quot; , :uri ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;//domain.com&quot; , :uri ) { :error , nil } iex&gt; Mahaul.Parser . parse ( &quot;//192.168.0.1&quot; , :uri ) { :error , nil }","ref":"Mahaul.Parser.html#parse/2","title":"Mahaul.Parser.parse/2","type":"function"}]